classificaSolo <-
function(dados,class.dados=TRUE,plot.dados=TRUE,
                           newClass=TRUE,new.comp,plot.new=TRUE){
  ## dados:: data frame com 3 colunas - areia,silte,argila
  ## plot.dados: gera o diagrama de class. incluindo a amostra
  ## newClass: TRUE, se deseja classificar uma nova composição
  ## new.comp: vetor correspondente aos valores da nova composição
  ## plot.new: plota o ponto a classificar no diagrama
  ##***************************
  ##  Composicao
  ##**************************
  dados <- as.matrix(dados)
  res <- c()
    for(i in 1:nrow(dados)) {
    res <- rowSums(dados)
    VF <- res[i]!= 100
    if(VF=='TRUE'){
      #print('soma difere de 1')
    }
      dados[i,] <- (dados[i,]/sum(dados[i,]))*100
  }
  data(tab.coord.pol)
  tab.pol <- tab.coord.pol
  poligono <- list()
  poligono[[1]]<- tab.pol[1:4,]
  poligono[[2]]<- tab.pol[5:10,]
  poligono[[3]]<- tab.pol[11:14,]
  poligono[[4]]<- tab.pol[15:18,]
  poligono[[5]]<- tab.pol[19:23,]
  poligono[[6]]<- tab.pol[24:28,]
  poligono[[7]]<- tab.pol[29:34,]
  poligono[[8]]<- tab.pol[42:35,]
  poligono[[9]]<- tab.pol[43:48,]
  poligono[[10]]<- tab.pol[49:55,]
  poligono[[11]]<- tab.pol[56:60,]
  poligono[[12]]<- tab.pol[61:65,]
  poligono[[13]]<- tab.pol[66:69,]
  ##******************************
  ##  Composicao 2D
  ##******************************
  #require(sp)
  poligono2D <- list()
  poligono2D[[1]] <- Polygon(as.matrix(data.frame(x=c(c((poligono[[1]]$Silte-poligono[[1]]$Areia)*sqrt(1/3),poligono[[1]]$Argila)[1:4]),y=c((poligono[[1]]$Silte-poligono[[1]]$Areia)*sqrt(1/3),poligono[[1]]$Argila)[5:8])))
  poligono2D[[2]] <- Polygon(as.matrix(data.frame(c(c((poligono[[2]]$Silte-poligono[[2]]$Areia)*sqrt(1/3),poligono[[2]]$Argila)[1:6]),c((poligono[[2]]$Silte-poligono[[2]]$Areia)*sqrt(1/3),poligono[[2]]$Argila)[7:12])))
  poligono2D[[3]] <- Polygon(as.matrix(data.frame(c(c((poligono[[3]]$Silte-poligono[[3]]$Areia)*sqrt(1/3),poligono[[3]]$Argila)[1:4]),c((poligono[[3]]$Silte-poligono[[3]]$Areia)*sqrt(1/3),poligono[[3]]$Argila)[5:8])))                              
  poligono2D[[4]] <- Polygon(as.matrix(data.frame(c(c((poligono[[4]]$Silte-poligono[[4]]$Areia)*sqrt(1/3),poligono[[4]]$Argila)[1:4]),c((poligono[[4]]$Silte-poligono[[4]]$Areia)*sqrt(1/3),poligono[[4]]$Argila)[5:8])))
  poligono2D[[5]] <- Polygon(as.matrix(data.frame(c(c((poligono[[5]]$Silte-poligono[[5]]$Areia)*sqrt(1/3),poligono[[5]]$Argila)[1:5]),c((poligono[[5]]$Silte-poligono[[5]]$Areia)*sqrt(1/3),poligono[[5]]$Argila)[6:10])))
  poligono2D[[6]] <- Polygon(as.matrix(data.frame(c(c((poligono[[6]]$Silte-poligono[[6]]$Areia)*sqrt(1/3),poligono[[6]]$Argila)[1:5]),c((poligono[[6]]$Silte-poligono[[6]]$Areia)*sqrt(1/3),poligono[[6]]$Argila)[6:10])))
  poligono2D[[7]] <- Polygon(as.matrix(data.frame(c(c((poligono[[7]]$Silte-poligono[[7]]$Areia)*sqrt(1/3),poligono[[7]]$Argila)[1:6]),c((poligono[[7]]$Silte-poligono[[7]]$Areia)*sqrt(1/3),poligono[[7]]$Argila)[7:12])))
  poligono2D[[8]] <- Polygon(as.matrix(data.frame(c(c((poligono[[8]]$Silte-poligono[[8]]$Areia)*sqrt(1/3),poligono[[8]]$Argila)[1:8]),c((poligono[[8]]$Silte-poligono[[8]]$Areia)*sqrt(1/3),poligono[[8]]$Argila)[9:16])))
  poligono2D[[9]] <- Polygon(as.matrix(data.frame(c(c((poligono[[9]]$Silte-poligono[[9]]$Areia)*sqrt(1/3),poligono[[9]]$Argila)[1:6]),c((poligono[[9]]$Silte-poligono[[9]]$Areia)*sqrt(1/3),poligono[[9]]$Argila)[7:12])))
  poligono2D[[10]] <- Polygon(as.matrix(data.frame(c(c((poligono[[10]]$Silte-poligono[[10]]$Areia)*sqrt(1/3),poligono[[10]]$Argila)[1:7]),c((poligono[[10]]$Silte-poligono[[10]]$Areia)*sqrt(1/3),poligono[[10]]$Argila)[8:14])))
  poligono2D[[11]] <- Polygon(as.matrix(data.frame(c(c((poligono[[11]]$Silte-poligono[[11]]$Areia)*sqrt(1/3),poligono[[11]]$Argila)[1:5]),c((poligono[[11]]$Silte-poligono[[11]]$Areia)*sqrt(1/3),poligono[[11]]$Argila)[6:10])))
  poligono2D[[12]] <- Polygon(as.matrix(data.frame(c(c((poligono[[12]]$Silte-poligono[[12]]$Areia)*sqrt(1/3),poligono[[12]]$Argila)[1:5]),c((poligono[[12]]$Silte-poligono[[12]]$Areia)*sqrt(1/3),poligono[[12]]$Argila)[6:10])))
  poligono2D[[13]] <- Polygon(as.matrix(data.frame(c(c((poligono[[13]]$Silte-poligono[[13]]$Areia)*sqrt(1/3),poligono[[13]]$Argila)[1:4]),c((poligono[[13]]$Silte-poligono[[13]]$Areia)*sqrt(1/3),poligono[[13]]$Argila)[5:8])))
  ##****************************
  ## Diagrama de Classificacao 
  ##****************************
  if(plot.dados==TRUE){
  z <- SpatialPolygons(list(Polygons(poligono2D,"Triangulo de Classificacao")))
  par(mgp=c(1.7,0.7,0))
  plot(z,axes='F')
  ## legendas dos vertices
  sp.text(loc=c(360,95),txt='Argila',add=TRUE)
  sp.text(loc=c(100,557),txt='Areia',add=TRUE)
  sp.text(loc=c(610,557),txt='Silte',add=TRUE)
  ## legendas internas aos poligonos
  sp.text(loc=c(360,200),txt='Muito argilosa',cex=0.8,add=TRUE)
  sp.text(loc=c(180,520),txt='Areia',cex=0.8,add=TRUE)
  sp.text(loc=c(130,535),txt='Areia',cex=0.8,add=TRUE)  
  sp.text(loc=c(200,535),txt='Franca',cex=0.8,add=TRUE)
  sp.text(loc=c(250,500),txt='Franco-arenoso',cex=0.8,add=TRUE)  
  sp.text(loc=c(235,420),txt='Franco',cex=0.8,add=TRUE)
  sp.text(loc=c(233,440),txt='argilo-arenosa',cex=0.8,add=TRUE)
  sp.text(loc=c(230,365),txt='Argila',cex=0.8,add=TRUE) 
  sp.text(loc=c(250,380),txt='arenosa',cex=0.8,add=TRUE)
  sp.text(loc=c(270,300),txt='Argila',cex=0.8,add=TRUE)
  sp.text(loc=c(350,460),txt='Franco',cex=0.8,add=TRUE)
  sp.text(loc=c(380,415),txt='Franco-argiloso',cex=0.8,add=TRUE)
  sp.text(loc=c(480,480),txt='Franco-siltoso',cex=0.8,add=TRUE)  
  sp.text(loc=c(555,520),txt='Silte',cex=0.8,add=TRUE)
  sp.text(loc=c(460,390),txt='Franco',cex=0.8,add=TRUE)
  sp.text(loc=c(475,410),txt='argilo-siltoso',cex=0.8,add=TRUE)
  sp.text(loc=c(460,338),txt='Argila',cex=0.8,add=TRUE)
  sp.text(loc=c(460,350),txt='siltosa',cex=0.8,add=TRUE)
  }
  ##
  if(class.dados==TRUE){
    class.amostra <- c()
    for(i in 1:nrow(dados)){
      x <- dados[i,]
      class.amostra[i] <- classSolo(x,poligono2D)
      print(i)
    }
    classifica.amostra <- data.frame(dados,class.amostra)
    Tabela.class <- data.frame(table(class.amostra)/100)
  }
  if(plot.dados==TRUE){
    dados.comp <- dados/100
    dados.comp.2D <- data.frame((dados.comp[,2]-dados.comp[,1])*sqrt(1/3),dados.comp[,3])
    names(dados.comp.2D) <- c('x','y')
    points(dados.comp.2D$x,dados.comp.2D$y,cex=0.5)
  }
  if(newClass==TRUE){
    x <- new.comp
    resul.class <- classSolo(x,poligono2D)
  }
  if(plot.new==TRUE){  
    x <- new.comp/100
    x2D <- c((x[2]-x[1])*sqrt(1/3),x[3])
    points(x=x2D[1],y=x2D[2],col='red',cex=1,pch=18)
  }
  retorna <- list()
  retorna[[1]] <- classifica.amostra 
  retorna[[2]] <- Tabela.class
  if(newClass==TRUE){
  retorna[[3]] <- resul.class
  }
  return(retorna)
}

