monta.V <-
function(theta1,dados.comp){
y <- dados.comp[[2]][[1]]
eta <- theta1[1]
nu1 <- theta1[2]
nu2 <- theta1[3]
phi <- theta1[4]
rho <- theta1[5]

## Calculando os elementos da matriz de correlacao espacial
distancia <- unname(as.matrix(dist(dados.comp[[3]],diag=TRUE,upper=TRUE)))
correla <- exp(-distancia/phi)

## Organizando a matriz de correlacao espacial com eltos y1 e y2 intercalados
## Ou seja, calculando R1
coluna1 <- rep(c(1, eta),length(y)/2)
coluna2 <- rep(c(eta,eta^2),length(y)/2)

seq1 <- seq(1,length(y),by=2)
seq2 <- seq(2,length(y),by=2)

ERRE1 <- matrix(ncol=length(y),nrow=length(y))
ERRE1[,c(seq1)] <- coluna1
ERRE1[,c(seq2)] <- coluna2

## Organizando a matriz de correlacao espacial com eltos y1 e y2 intercalados
ERRE2 <- matrix(nrow=length(y),ncol=length(y))
for(i in 1:length(y)/2){
  ERRE2[seq1[i],] <- rep(correla[i,],each=2)
  ERRE2[seq2[i],] <- rep(correla[i,],each=2)}

## Calculando a matriz R
ERRE <- ERRE1*ERRE2

## Calculando a matriz de covariancia composicional
Ib1 <- matrix(c(nu1^2,nu1*nu2*rho,nu1*nu2*rho,nu2^2),nc=2)
Ib <- kronecker(diag(length(y)/2),Ib1)

## Matriz de covariancia espacial composicional
V <- ERRE + Ib
return(V)
}

