resultado.mh <-
function(resultado)
  {
    post.beta1 <- resultado[[1]]$beta1
    post.beta2 <- resultado[[1]]$beta2
    post.sigma1 <- resultado[[1]]$sigma1
    post.sigma2 <- post.sigma1*resultado[[2]]$eta
    post.tau1 <- post.sigma1*resultado[[2]]$nu1
    post.tau2 <- post.sigma1*resultado[[2]]$nu2
    post.phi <- resultado[[2]]$phi
    post.rho <- resultado[[2]]$rho
    saida <- data.frame(post.beta1,post.beta2,post.sigma1,post.sigma2,post.tau1,post.tau2,post.phi,post.rho)
    #jpeg()
    par(mfrow=c(2,4))
    plot(density(post.beta1),main="Posteriori mu1")
    plot(density(post.beta2),main="Posteriori mu2")
    plot(density(post.sigma1),main="Posteriori s1")
    plot(density(post.sigma2),main="Posteriori s2")
    plot(density(post.tau1),main="Posteriori t1")
    plot(density(post.tau2),main="Posteriori t2")
    plot(density(post.phi),main="Posteriori phi")
    plot(density(post.rho),main="Posteriori rho")
    #dev.off()
    m1<-c(quantile(post.beta1,prob=0.025),mean(post.beta1),quantile(post.beta1,prob=0.975))
    m2<-c(quantile(post.beta2,prob=0.025),mean(post.beta2),quantile(post.beta2,prob=0.975))
    s1<-c(quantile(post.sigma1,prob=0.025),mean(post.sigma1),quantile(post.sigma1,prob=0.975))
    s2<-c(quantile(post.sigma2,prob=0.025),mean(post.sigma2),quantile(post.sigma2,prob=0.975))
    t1<-c(quantile(post.tau1,prob=0.025),mean(post.tau1),quantile(post.tau1,prob=0.975))
    t2<-c(quantile(post.tau2,prob=0.025),mean(post.tau2),quantile(post.tau2,prob=0.975))
    phi<-c(quantile(post.phi,prob=0.025),median(post.phi),quantile(post.phi,prob=0.975))
    rho<-c(quantile(post.rho,prob=0.025),mean(post.rho),quantile(post.rho,prob=0.975))
    tabela <- t(data.frame(m1,m2,s1,s2,t1,t2,phi,rho))
    estimativa.optim <- estima.bayes[[3]]
    retorna <- list()
    retorna[[1]] <- saida
    retorna[[2]] <- tabela
    retorna[[3]] <- estimativa.optim
    return(retorna)
  }

