\name{agl}
\alias{agl}

%- Also NEED an '\alias' for EACH other topic documented here.

\encoding{utf-8}

\title{
     Transformação ALR inversa.
}
\description{
     A função transforma um vetor bivariado, de dados ALR transformados,
     em um vetor trivariado, uma composição.
}
\usage{
agl(dados)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{dados}{Vetor bivariado de dados ALR transformados.}
}
%\details{
%  ~~ If necessary, more details than the description above ~~
%}
\value{
  A função retorna um vetor correspondente a composição.
}
\references{ 
    Martins, A. B. T., and Ribeiro Jr, P. J., and Bonat, W. H., (2009). Um modelo geoestatístico para 
    dados composicionais. \emph{Revista Brasileira de Biometria} \bold{27}, n. 3, 456-477.
}
\author{ 
  Wagner Hugo Bonat \email{wagner@leg.ufpr.br}, \cr
  Ana Beatriz Tozzo Martins \email{abtmartins@uem.br}, \cr
  Paulo Justiniano Ribeiro Jr. \email{paulojus@leg.ufpr.br}.
}
%\note{ ~~further notes~~ 
% ~Make other sections like Warning with \section{Warning }{....} ~
%}
%\seealso{ ~~objects to See Also as \code{\link{help}}, ~~~ }
\examples{
x<-c(0.5,0.3)
agl(x)
}
\keyword{manip}
